const {
  DateTime,
  Duration,
  Interval
} = require('luxon')

const isType = require('./is-type')

const parseValue = (value) => {
  if (isType(value, 'float')) return parseFloat(value)
  else if (isType(value, 'integer')) return parseInt(value)
  else if (isType(value, 'date')) {
    if (value instanceof DateTime) return value
    if (value instanceof Date) return DateTime.fromJSDate(value)
    return DateTime.fromISO(value)
  }
  else if (isType(value, 'duration')) {
    if (value instanceof Duration) return value
    return Duration.fromISO(value)
  }
  else if (isType(value, 'interval')) {
    if (value instanceof Interval) return value
    return Interval.fromISO(value)
  }
  return value
}

module.exports = parseValue
