const {
  DateTime,
  Duration,
  Interval
} = require('luxon')

const stringifyValue = (value) => {
  if (typeof value === 'number') return value.toString()
  if (value instanceof Date) {
    return DateTime.fromJSDate(value).toISO()
  }
  if (value instanceof DateTime) {
    return value.toISO()
  }
  if (value instanceof Duration) {
    return value.toISO()
  }
  if (value instanceof Interval) {
    return value.toISO()
  }
  return value
}

module.exports = stringifyValue
