const jsonld = require('jsonld')

class JSONLD {
  constructor (document, context) {
    this._document = document
    this._context = context
  }

  async toJSONLD (expand = false) {
    let compact
    if (typeof this._context === 'string') {
      compact = Object.assign({
        '@context': this._context
      }, this._document)
    }
    else compact = await jsonld.compact(this._document, this._context)
    if (expand) {
      const expanded = await jsonld.expand(compact)
      return expanded
    }
    else return compact
  }

  async toRDF () {
    const ld = await this.toJSONLD()
    const rdf = await jsonld.toRDF(ld, {format: 'application/n-quads'})
    return rdf
  }

  async fromRDF (data) {
    const compact = await this.fromRDF(data, {format: 'application/n-quads'})
    return compact
  }
}

module.exports = JSONLD
