const jsonld = require('jsonld')
const Annotation = require('./index')

class AnnotationFactory {
  static async fromFlatJsonLd (data) {
    // FIXME: remove annotation type hack!
    data = data.map(item => {
      if (item['http://www.w3.org/ns/oa#hasBody']) item['@type'] = ['Annotation']
      return item
    })
    const ld = await jsonld.frame({
      '@context': 'https://www.w3.org/ns/anno.jsonld',
      '@graph': data
    }, {
      '@context': 'https://www.w3.org/ns/anno.jsonld',
      '@type': 'Annotation'
    })
    return Array.isArray(ld['@graph']) ? ld['@graph'].map(item => {
      // FIXME: remove creator hack
      if (item['dc:creator']) item['creator'] = item['dc:creator']
      return new Annotation(item)
    }) : []
  }
}

module.exports = AnnotationFactory
