const SchemaObject = require('schema-object')

const
  constants = require('../../../constants'),
  Source = require('./source'),
  Selector = require('./selector')

const Body = new SchemaObject({
  id: { type: String },

  // TODO: add to tests
  format: { type: String },
  type: { type: String },
  value: { type: String },

  // TODO: add to tests
  language: [{ type: String }],
  textDirection: { type: String, enum: ['ltr', 'rtl', 'auto'] },
  processingLanguage: { type: String },

  source: {
    type: Source,
    transform: value => {
      if (typeof value === 'string') value = { id: value }
      return value
    }
  },
  selector: { type: Selector },
  purpose: { type: String, enum: constants.ANNOTATION_MOTIVATIONS }
}, {
  strict: false
})

module.exports = Body
