const SchemaObject = require('schema-object')
const Selector = require('./selector')
const Source = require('./source')

const Target = new SchemaObject({
  type: { type: String },
  id: { type: String },
  source: {
    type: Source,
    transform: value => {
      if (typeof value === 'string') value = { id: value }
      return value
    }
  },
  selector: { type: Selector },

  // TODO: add to tests
  language: [{ type: String }],
  textDirection: { type: String, enum: ['ltr', 'rtl', 'auto'] },
  processingLanguage: { type: String }
}, {
  strict: false
})

module.exports = Target
