const SchemaObject = require('schema-object')

const constants = require('../../constants')
const { constructors, computed, methods, setSpecialFields } = require('../../defaults')
const { Person, SerializedObject, Stylesheet } = require('../internal')

const schema = setSpecialFields('cells', {
  '@context': {
    type: String,
    readOnly: true,
    getter: () => `${constants.BASE_URI_NS}cell.jsonld`
  },
  creator: Person,
  source: SerializedObject,
  configuration: SerializedObject,
  stylesheet: Stylesheet
})

const config = {
  strict: true,
  constructors,
  computed,
  methods
}

const Cell = new SchemaObject(schema, config)
Cell.schema = schema

module.exports = Cell
