const SchemaObject = require('schema-object')

const constants = require('../../constants')
const { constructors, computed, methods, setSpecialFields } = require('../../defaults')
const { Person, Stylesheet } = require('../internal')

const schema = setSpecialFields('components', {
  '@context': {
    type: String,
    readOnly: true,
    getter: () => `${constants.BASE_URI_NS}component.jsonld`
  },
  creator: Person,
  title: { type: String, required: true },
  tag: String,
  javascript: { type: String, required: true },
  html: { type: String, required: true },
  stylesheet: Stylesheet
})

const config = {
  strict: true,
  constructors,
  computed,
  methods
}

const Component = new SchemaObject(schema, config)
Component.schema = schema

module.exports = Component
