const SchemaObject = require('schema-object')

const { constructors, computed, methods, setSpecialFields } = require('../../defaults')
const { Person } = require('../internal')
const Track = require('./sub-models/track')

const schema = setSpecialFields('data-packages', {
  creator: { type: Person },
  playerVersion: { type: String, default: '2' },
  time: { type: String },
  tracks: { type: [Track] }
})

const config = {
  strict: true,
  constructors,
  computed,
  methods
}

const DataPackage = new SchemaObject(schema, config)
DataPackage.schema = schema

module.exports = DataPackage
