const
  SchemaObject = require('schema-object'),
  { constructors, methods, setSpecialFields } = require('../../defaults'),
  { fromIngestedMediaFile } = require('./converters'),
  { Source, Person } = require('../internal'),
  subModels = require('./sub-models')

/**
 * Main Document Type
 */
const schema = setSpecialFields('documents', {
  /** Document ID & ownership **/
  creator: { type: Person, required: true },

  /** Content metadata **/
  source: { type: Source },
  file: { type: subModels.FileMetadata },
  media: { type: subModels.MediaMetadata }
})

const docConstructors = constructors
docConstructors.fromIngestedMediaFile = fromIngestedMediaFile

const config = {
  strict: true,
  methods,
  constructors: docConstructors
}

const Document = new SchemaObject(schema, config)
Document.schema = schema

module.exports = Document
