const SchemaObject = require('schema-object')
const { uuid } = require('mbjs-utils')
const constants = require('../../constants')

const Person = new SchemaObject({
  name: { type: String },
  uuid: { type: String },
  id: {
    type: String,
    transform: function (value) {
      if (typeof value !== 'string') {
        this.format = 'application/json'
        return JSON.stringify(value)
      }
      else {
        if (uuid.isUUID(value)) {
          return `${constants.BASE_URI}persons/${value}`
        }
      }
      return value
    }
  }
}, { strict: true })

module.exports = Person
