const SchemaObject = require('schema-object')

const SerializedObject = new SchemaObject({
  value: {
    type: String,
    transform: function (value) {
      if (typeof value !== 'string') {
        this.format = 'application/json'
        return JSON.stringify(value)
      }
      return value
    }
  },
  _value: {
    type: 'any',
    readOnly: true,
    getter: function () {
      if (this.value && this.format === 'application/json') {
        return JSON.parse(this.value)
      }
      return this.value
    }
  },
  format: { type: String },
  id: { type: String }
})

module.exports = SerializedObject
